'use strict'

const Koa = require('koa');
const rtapi = require('koa-rtapi');
const kapp = new Koa();

/** 配置服务 */
const cfg = {

    // 监听端口
    port: 1986,

    // api路由配置
    apis: [
        { path: '/api/', dir: '/api/' }
    ],

    // 环境变量
    env: {
        root: __dirname,
        mysql: {
            db1: { host: '192.168.1.191', port: '3306', user: 'rtworld', password: 'rtworld123456', database: 'rtworld_dew' }
        }
    },

    // 日志
    rlog: function (k1, k2, k3) {
        const t = this;
        if (typeof k1 === 'object') {
            console.log(k1);
        } else {
            let r = `--- ${t.rid} : ${new Date().toLocaleString()} [${k1}] ${k2}`;
            if (k3 !== undefined) { r += ` | ${util.inspect(k3)}`; }
            console.log(r);
        }
    }
};


/** 启动服务 */
kapp.use(rtapi.env(cfg.env, cfg.rlog))                        // 添加配置
    .use(require('koa-bodyparser')())                         // 支持post-body
    .use(rtapi.api(cfg.apis))                                 // 开启rtapi
    .listen(cfg.port);                                        // 开始监听


/** 提示信息 */
console.log(`
-----------------------------------
- 服务已启动
- 地址：http://127.0.0.1:${cfg.port}/
- 测试：http://127.0.0.1:${cfg.port}/api/demo/hello
- 退出：ctrl + c
-----------------------------------
`);
