/*<%#
    const table = $b.table;
    const name = table.TABLE_NAME;
    const columns = table.COLUMNS;
%>*/

'use strict';

const { ManageBase } = require('koa-rtapi');
const ApiAccess = require('./_apiAccess');

/** <%= name %> <%=  table.TABLE_COMMENT %> */
module.exports = class extends ManageBase {

    /** 数据入口 */
    get access() {
        return new ApiAccess(this.ctx)['<%= name %>'];
    }

    /** 表结构 */
    // <%# const idField = columns[0].COLUMN_NAME; %>
    buildSchema() {
        return {
            tableName: '<%= name %>',
            tableComment: '<%= table.TABLE_COMMENT %>',
            idField: '<%= idField %>',
            pagerSize: 10,
            sortField: '<%= idField %>',
            sortDesc: false,
            fields: [
                // <%# let i = 0; %>
                // <%# for (const c of columns) { %>
                // <%# const name = c.COLUMN_NAME; %>
                // <%# const nick = (c.COLUMN_COMMENT || name).substr(0,20).split(' ')[0]; %>
                // <%# if (i==0) { %>
                { field: '<%= name %>', name: '<%= nick %>', show: true, sortEnable: true, type: '<%= c.COLUMN_TYPE %>', width: 100 },
                // <%# } else if (c.COLUMN_TYPE != 'text') { %>
                { field: '<%= name %>', name: '<%= nick %>', show: true, sortEnable: true, type: '<%= c.COLUMN_TYPE %>', width: 200 },
                // <%# } else { %>
                { field: '<%= name %>', name: '<%= nick %>', show: false, sortEnable: false, type: '<%= c.COLUMN_TYPE %>', width: 300 },
                // <%# } %>
                // <%# i++; %>
                // <%# } %>
            ],
            metaMap: {},
            condition: null
        }
    }

    /** 搜索条件 */
    buildSearcher(body) {
        const result = this.searchOpt(body)
            // <%# for (const c of columns) { %>
            .setCondition('<%= c.COLUMN_NAME %>', '`<%= c.COLUMN_NAME %>`=?')     // <%= c.COLUMN_COMMENT %>
        // <%# } %>

        return result;
    }

    /** 添加/修改的数据 method=create|update*/
    buildData(body, method) {
        const t = this;
        return {
            // <%# for (const c of columns) { %>
            // <%# if (c.COLUMN_KEY === 'PRI') { continue; } %>
            // <%# const cname = c.COLUMN_NAME; %>
            // <%# if (/time|date/i.test(c.DATA_TYPE)) { %>
            '<%= cname %>': new Date(t.value(body['<%= cname %>'])),     // <%= c.COLUMN_COMMENT %>
            // <%# } else { %>
            '<%= cname %>': t.value(body['<%= cname %>']),     // <%= c.COLUMN_COMMENT %>
            // <%# } %>
            // <%# } %>
        };
    }
}