﻿/*<%#
    const table = $b.table;
    const name = table.TABLE_NAME;
    const columns = table.COLUMNS;
%>*/

// <%= name %> <%=  table.TABLE_COMMENT %>
xf.module({

    name: 'v-<%= name %>-grid',

    using: [
        xf.builder('tkui'),
        xf.builder('tkui.grid')
    ],

    view: function (context, tkui, grid) {

        // 初始化
        var ui = new tkui(context, {
            title: '<%= table.TABLE_COMMENT %> (<%= name %>)',
            controller: '<%= name %>',
            initModules: [grid]
        });

        // 列表部分
        var list = ui.vue('list', grid.list, grid.listExt, {

            static: {
                // 编辑视图的名称
                editViewName: '@<%= name %>-edit',

                // 行描述（用于手机版页面)
                rowDescription: function (row) {
                    var tmp = [
                        '<div>',
                        '{{<%= columns[0].COLUMN_NAME %>}} - ',
                        '{{<%= columns[1].COLUMN_NAME %>}}',
                        '</div>'
                    ].join('');
                    return xf.fill(tmp, row);
                },

                /*<%#
                    for (const c of columns) {
                        var ccomment = c.COLUMN_COMMENT || '';
                        var select = ccomment.match(/\[\=(.+)\]/);
                        var outer = ccomment.match(/\#\w+\.\w+\:\w+/g);
                        if (select){
                            var exp = select[1].replace(/\:|\,/g, function (n) { return '"' + n + '"' });
                %>*/
                '#<%= c.COLUMN_NAME%>': function (row, col) {
                    var map = JSON.parse('{"<%= exp %>"}');
                    return map[row[col]];
                },
                /*<%#
                        } else if (outer) {
                            const csec = outer[0].split(/\#|\.|\:/);
                %>*/
                '#<%= c.COLUMN_NAME%>': function (row, col) {
                    const val = row[col];
                    const data = row[col + '__data'];
                    return val + ' [ ' + (data ? data['<%= csec[3] %>'] : '') + ' ]';
                },
                // <%# }} %>
            },

            data: {},

            methods: {}
        });

        // 搜索部分
        var search = ui.vue('search', grid.search, {

            static: {
                checker: {
                    // <%# for (const c of columns) { %>
                    // <%# const cnick = (c.COLUMN_COMMENT || c.COLUMN_NAME).split(' ')[0]; %>
                    '<%= c.COLUMN_NAME %>': { rgx: /.*/, msg: '<%= cnick %>输入有误' },
                    // <%# } %>
                }
            },

            data: {
                condition: {
                    // <%# for (const c of columns) { %>
                    '<%= c.COLUMN_NAME %>': '',
                    // <%# } %>
                },
                condition_exp: {
                    // <%# for (const c of columns) { %>
                    // <%# const outer = (c.COLUMN_COMMENT || '').match(/\#(\w+\.\w+\:\w+)/g); %>
                    // <%# if (!outer) { continue; } %>
                    '<%= c.COLUMN_NAME %>': '-- 请选择 --',
                    // <%# } %>
                }
            },

            watch: {
                // <%# for (const c of columns) { %>
                // <%# const outer = (c.COLUMN_COMMENT || '').match(/\#(\w+\.\w+\:\w+)/g); %>
                // <%# if (!outer) { continue; } %>
                'condition.<%= c.COLUMN_NAME %>': function (v) {
                    this.Modal.setOuterExp('<%= outer %>', v, this.condition_exp, '<%= c.COLUMN_NAME %>');
                },
                // <%# } %>
            },

            methods: {}
        });

        // 初始化
        ui.ready(function (para) {
            list.loadMeta(function () {
                if (para && para.condition) {
                    Object.assign(search.condition, para.condition);
                }
                search.search();
                // list.search(true);
            });
            if (para && para.mode == 'select') {
                context.view.title += ' [选择对象]'
            }
        });
    }
});
