'use strict'

const Koa = require('koa');
const rtapi = require('koa-rtapi');

/** 配置服务 */
const cfg = {

    // 监听端口
    port: 1986,

    // api路由配置
    apis: [
        { path: '/api/', dir: '/api/' }
    ],

    // 静态配置
    stc: {
        root: `${__dirname}/www`,
        opts: {}
    },

    // 环境变量
    env: {
        root: __dirname,
        mysql: {
            db1: { host: '192.168.1.191', port: '3306', user: 'rtworld', password: 'rtworld123456', database: 'rtworld_dew' }
        }
    },

    // 日志
    rlog: require('./lib/rlog')
};


/** 启动服务 */
const kapp = new Koa();
kapp.use(rtapi.env(cfg.env, cfg.rlog))                        // 添加配置
    .use(require('koa2-cors')())                              // 开启跨域
    .use(require('koa-static')(cfg.stc.root, cfg.stc.opts))   // 静态支持
    .use(require('koa-bodyparser')())                         // 支持post-body
    .use(rtapi.api(cfg.apis))                                 // 开启rtapi
    .listen(cfg.port);                                        // 开始监听


/** 提示信息 */
console.log(`
-----------------------------------
- 服务已启动
- 地址：http://127.0.0.1:${cfg.port}/
- 退出：ctrl + c
-----------------------------------
`);
