
let urlHeader = '/api/coding/';
let query = function (key, _) {
    _ = location.search.match(new RegExp('[\?\&]' + key + '=([^\&\#]*)', 'i'));
    return _ ? decodeURIComponent(_[1]) : '';
};

let fileList = new Vue({
    el: '#app',
    data: {
        mode: 'list',
        path: [],
        dirs: [],
        files: [],
        file: '',
        code: ''
    },
    methods: {

        init: function () {
            let t = this;
            t.goin(0);
        },

        // 进入目录
        goin: function (item) {
            let t = this;
            t.mode = 'list';
            t.code = '';

            if (typeof item === 'string') {
                t.path.push(item);
            } else if (typeof item === 'number') {
                let tmp = t.path;
                tmp.length = item + 1;
                t.path = tmp;
            }

            t.post('readDir', { path: t.path.join('/') }, function (json) {
                t.dirs = json.dirs;
                t.files = json.files;
            });
        },

        // 创建
        create: function () {
            let t = this;

            let name = prompt('输入文件名，或以 / 结尾的文件夹名');
            if (!name) { return; }

            let path = t.path.join('/') + '/' + name;
            t.post('create', { path: path }, function (json) {
                t.goin();
            });
        },

        // 读取
        read: function (item) {
            let t = this;
            let path = t.path.join('/') + '/' + item;

            t.file = item;
            t.mode = 'code';
            t.post('readFile', { path: path }, function (json) {
                t.code = json.data;
                Vue.nextTick(function () {
                    hljs.highlightBlock(document.querySelector('.lang-js'));
                });
            });
        },

        // 删除
        remove: function (item, isDir) {
            let t = this;

            if (!confirm('确定删除？')) { return; }

            let name = isDir ? 'removeDir' : 'removeFile';
            let path = t.path.join('/') + '/' + item;

            t.post(name, { path: path }, function (json) {
                alert('删除成功');
                t.goin();
            });
        },

        // 保存代码
        save: function () {
            let t = this;
            let path = t.path.join('/') + '/' + t.file;
            let code = t.code;
            t.post('writeFile', { path: path, code: code }, function (json) {
                if (json.success) {
                    t.preview();
                } else {
                    alert('保存失败');
                }
            })
        },

        // 预览代码
        preview: function () {
            let t = this;
            t.mode = 'code';
            Vue.nextTick(function () {
                hljs.highlightBlock(document.querySelector('.lang-js'));
            });
        },

        // 发送请求
        post: function (name, json, fn) {
            let t = this;
            let xhr = new XMLHttpRequest();
            xhr.onreadystatechange = () => {
                if (xhr.readyState !== 4) { return; }
                if (xhr.status === 200) {
                    fn(JSON.parse(xhr.responseText));
                } else {
                    alert(xhr.responseText);
                }
            };
            xhr.open('POST', urlHeader + name, true);
            xhr.setRequestHeader("Content-type", "application/json");
            xhr.send(JSON.stringify(json));
        }
    }
});

fileList.init();