﻿xf.module({

    name: 'DEditor.Form',

    using: [
        'css!../tkui.css'
    ],

    module: {

        init: function(page) {
            var el = page.context.el;
            var list = el.classList;
            list.add('tk-view');
            list.add('tk-form');
        },

        body: {

            static: {

            },

            data: {
                mode: 1 // 1-创建模式; 2-编辑模式
            },

            computed: {
                metaMap: function() {
                    return this.Context.para.metaMap;
                }
            },

            methods: {

                // 推测题目
                getName: function(name) {
                    var t = this;
                    var arr = t.Context.para.fields || [];
                    var field = arr.filter(function(n) {
                        return n.field === name;
                    });
                    return field[0] ? field[0].name : name;
                },

                // 载入记录
                load: function(id) {
                    var t = this;
                    var para = { id: id };
                    var fields = t.Context.para.fields || []; // 字段配置

                    t.Modal.post('@find', para).done(function(result) {
                        for (var k in t.row) {
                            var v = result[k];

                            // 处理时间
                            var f = fields.find(n => n.field === k);
                            if (f && /time|date/i.test(f.type)) {
                                v = xf.date(new Date(v), 'yyyy-MM-dd HH:mm:ss')
                            }

                            t.row[k] = v;
                        }
                    });
                },

                // 保存记录
                save: function() {
                    var t = this;
                    var para = t.row;

                    var msg = t.Modal.checker(para, t.checker, { box: t.$el });
                    if (msg) {
                        if (msg.length) { alert(msg.join('\n')); }
                        return;
                    }

                    var aName = t.mode === 1 ? '@create' : '@update';
                    t.Modal.post(aName, para).done(function(json) {
                        t.Modal.callback({});
                        t.Page.back();
                    });
                },

                // 重新载入
                reset: function() {
                    var t = this;
                    t.load();
                },

                // 所有输入都可用
                enableAll: function() {

                    var all = this.$el.querySelectorAll('[disabled]');
                    for (var i = 0; i < all.length; i++) {
                        all[i].disabled = false;
                    }

                }
            }
        }
    }
});