
(function () {
    var $server = xf.config = {

        v: '1.0',                           /* 版本号 */
        view_root: '/',             /* 视图根路径 */
        view_ext: '/',                      /* 视图扩展名，服务器渲染:.view2js, 浏览器渲染:/  */

        builder: function (name) {          /* 约定的构建器 */
            var arr = name.split('.');
            return [
                'builders/',
                arr.join('/'),
                '/',
                arr[arr.length - 1],
                '.js'
            ].join('');
        },

        view_name2url: function (name) {    /* 视图名称转换到网址 */
            var url = name.replace(/\./g, '/') + $server.view_ext;
            if (url[0] === '@') {
                url = $server.view_root + '/' + url.substring(1);
            }
            return url;
        },

        view_exts: {                        /* 视图资源扩展名配置 */
            js: '*.js',
            doc: 'text!*.html',
            css: 'css!*.css',
            builderHtml: 'text!./builders/*.html' /* 支持 ~/ */
        },

        container: {                        /* 容器配置 */
            animate: 'center',               /* 容器入场动画 */
            useDrag: true,                  /* 启用拖拽 */
            useCenter: true,                /* 自动居中 */
            useHeader: true,                /* 显示容器头 */
            width: '70%',                   /* 宽度 */
            height: '70%',                  /* 高度 */
            minWidth: 440,                  /* 最小宽度 */
            minHeight: 440,                 /* 最大宽度 */
            oncreated: function (view) { }  /* 创建容器完成后执行 */
        },

        api_name2url: function (name) {     /* api名称转url */
            return name.replace('@', '/api/xf-api/' + this.controller + '/');
        },

        api_ready: function (xhr) {         /* api调用完成 */

            // 服务器错误
            if (xhr.status !== 200) {
                return alert('服务器状态有误:' + xhr.status);
            }

            // 获取结果
            var json = JSON.parse(xhr.responseText);

            // 简单类型
            if (typeof json !== 'object') {
                return json;
            }

            // 业务类型
            var status = json.status;
            var result = json.result;

            switch (status) {
                case 'SUCCESS':
                    return result;

                case 'FAIL':
                    var failMsg = json.status_msg;
                    if (typeof result === 'string') {
                        failMsg += '\n' + result;
                    }
                    return alert(failMsg);

                default:
                    return alert(json.status_msg);
            }

        },

        require: {                          /* requirejs配置 */
            config: function () {
                return {
                    urlArgs: $server.v,
                    waitSeconds: 30
                }
            },

            onError: function (err) {
                //alert('模块错误：' + err.requireType + '\n-> ' + err.requireModules.join('\n-> '));
                throw err;
            }
        },
    }
})();
