
/** 表关联 */
(function (name) {
    var map = window[name] = {};

    /** 悬赏 */
    map['th_mission'] = {
        id: [
            { sheet: 'th_mission_data', field: 'mission_id', title: '悬赏数据' },
            { sheet: 'th_mission_work', field: 'mission_id', title: '悬赏任务' },
            { sheet: 'th_mission_reward', field: 'mission_id', title: '悬赏奖励' }
        ],
        user_id: { sheet: 'th_user', field: 'id', title: '用户' }
    };

    /** 悬赏数据 */
    map['th_mission_data'] = {
        mission_id: { sheet: 'th_mission', field: 'id', title: '悬赏' },
        category_id: { sheet: 'th_mission_data_category', field: 'id', title: '悬赏数据分类' }
    };

    /** 悬赏数据分类 */
    map['th_mission_data_category'] = {
        id: { sheet: 'th_mission_data', field: 'category_id', title: '悬赏数据' }
    };

    /** 悬赏奖励 */
    map['th_mission_reward'] = {
        id: { sheet: 'th_user_mission_reward', field: 'mission_reward_id', title: '用户悬赏奖励' },
        mission_id: { sheet: 'th_mission', field: 'id', title: '悬赏' },
        mission_work_id: { sheet: 'th_mission_work', field: 'id', title: '悬赏任务' },
        category_id: { sheet: 'th_mission_reward_category', field: 'id', title: '悬赏奖励分类' }
    };

    /** 悬赏奖励分类 */
    map['th_mission_reward_category'] = {
        id: { sheet: 'th_mission_reward', field: 'category_id', title: '悬赏奖励' },
    };

    /** 悬赏任务 */
    map['th_mission_work'] = {
        id: { sheet: 'th_user_mission_work', field: 'mission_work_id', title: '用户悬赏任务' },
        mission_id: { sheet: 'th_mission', field: 'id', title: '悬赏' },
        category_id: { sheet: 'th_mission_work_category', field: 'id', title: '悬赏任务类别' },
    };

    /** 悬赏任务类别 */
    map['th_mission_work_category'] = {
        id: { sheet: 'th_mission_work', field: 'category_id', title: '悬赏任务' },
    };

    /** 用户 */
    map['th_user'] = {
        id: [
            { sheet: 'th_user_data', field: 'user_id', title: '用户数据' },
            { sheet: 'th_user_mission', field: 'user_id', title: '用户悬赏' },
            { sheet: 'th_user_mission', field: 'from_user_id', title: '用户悬赏(来源)' },
            { sheet: 'th_mission', field: 'user_id', title: '悬赏' },
            { sheet: 'th_user_score', field: 'user_id', title: '用户积分' },
            { sheet: 'th_user_info', field: 'user_id', title: '用户信息' },
        ]
    };

    /** 用户数据 */
    map['th_user_data'] = {
        user_id: { sheet: 'th_user', field: 'id', title: '用户' },
        category_id: { sheet: 'th_user_data_category', field: 'id', title: '用户数据类别' },
    };

    /** 用户数据类别 */
    map['th_user_data_category'] = {
        id: { sheet: 'th_user_data', field: 'category_id', title: '用户数据' },
    };

    /** 用户信息 */
    map['th_user_info'] = {
        user_id: { sheet: 'th_user', field: 'id', title: '用户' },
        category_id: { sheet: 'th_user_info_category', field: 'id', title: '用户信息类别' },
    };

    /** 用户信息类别 */
    map['th_user_info_category'] = {
        id: { sheet: 'th_user_info', field: 'category_id', title: '用户信息' },
    };

    /** 用户悬赏 */
    map['th_user_mission'] = {
        id: [
            { sheet: 'th_user_mission_work', field: 'user_mission_id', title: '用户悬赏任务' },
            { sheet: 'th_user_mission_reward', field: 'user_mission_id', title: '用户悬赏奖励' },
        ],
        mission_id: { sheet: 'th_mission', field: 'id', title: '悬赏' },
        user_id: { sheet: 'th_user', field: 'id', title: '用户' },
        from_user_id: { sheet: 'th_user', field: 'id', title: '来源用户' },
    };

    /** 用户悬赏奖励 */
    map['th_user_mission_reward'] = {
        mission_reward_id: { sheet: 'th_mission_reward', field: 'id', title: '悬赏奖励' },
        user_mission_id: { sheet: 'th_user_mission', field: 'id', title: '用户悬赏' },
    };

    /** 用户悬赏任务 */
    map['th_user_mission_work'] = {
        mission_work_id: { sheet: 'th_mission_work', field: 'id', title: '悬赏任务' },
        user_mission_id: { sheet: 'th_user_mission', field: 'id', title: '用户悬赏' },
    };

    /** 用户积分 */
    map['th_user_score'] = {
        user_id: { sheet: 'th_user', field: 'id', title: '用户' },
    };

})('table_relate_map');