﻿
// 列表页面的范例
xf.module({

    name: 'v-dtpicker',

    using: [
        xf.builder('tkui'),
        xf.builder('tkui.form')
    ],

    view: function (context, tkui) {

        // 初始化
        var ui = new tkui(context, {
            title: '设置'
        });

        // 搜索部分
        var form = ui.vue('tk-form', {

            data: {
                date: '',
                time: ''
            },

            methods: {
                submit: function () {
                    const t = this;
                    if (!t.date || !t.time) { return; }
                    ui.callback(t.date + ' ' + t.time);
                    app.back();
                },

                setNow: function () {
                    const t = this;
                    t.setDate(new Date());
                },

                setDate: function (date) {
                    const t = this;
                    t.date = date.getFullYear()
                        + '-' + ('0' + (date.getMonth() + 1)).substr(-2)
                        + '-' + ('0' + date.getDate()).substr(-2);
                    t.time = ('0' + date.getHours()).substr(-2)
                        + ':' + ('0' + date.getMinutes()).substr(-2)
                        + ':' + ('0' + date.getSeconds()).substr(-2);

                }
            }
        });

        // 初始化
        ui.ready(function (para) {
            if (!para || !para.value) { return; }

            var date = new Date(para.value);
            form.date = xf.date(date, 'yyyy-MM-dd');
            form.time = xf.date(date, 'HH:mm:ss');
        });
    }
});