﻿
// 列表页面的范例
xf.module({

    name: 'v-view2-setting',

    using: [
        xf.builder('tkui'),
        xf.builder('tkui.grid')
    ],

    view: function (context, tkui) {

        // 初始化
        var ui = new tkui(context, {
            title: '页面设置'
        });

        // 搜索部分
        ui.vue('setting', {

            data: {
                tab: 1,
                List: null,
                about: '{{Setting.data.about}}',
                sortField: '',
                sortDesc: false,
                pagerSize: 0,
                fields: [],
                showMode: 'default',
                tableStyle: 'simple',
                command:''
            },

            methods: {
                up: function (i) {
                    var t = this;
                    if (i === 0) { return; }

                    var field = t.fields[i];
                    t.fields.splice(i, 1);
                    t.fields.splice(i - 1, 0, field);
                },
                down: function (i) {
                    var t = this;
                    if (i === t.fields.length-1) { return; }

                    var field = t.fields[i];
                    t.fields.splice(i, 1);
                    t.fields.splice(i + 1, 0, field);
                },
                apply: function () {
                    var t = this;
                    t.List.sortField = t.sortField;
                    t.List.sortDesc = t.sortDesc;
                    t.List.pagerSize = parseInt(t.pagerSize);
                    t.List.fields = JSON.copy(t.fields);
                    t.List.showMode = t.showMode;
                    t.List.tableStyle = t.tableStyle;
                    t.List.search(true);
                    t.Page.back();
                },
                reset: function () {
                    var t = this;
                    t.sortField = t.List.sortField;
                    t.sortDesc = t.List.sortDesc;
                    t.pagerSize = t.List.pagerSize;
                    t.fields = JSON.copy(t.List.fields);

                    t.showMode = t.List.showMode;
                    t.tableStyle = t.List.tableStyle;
                },

                // 执行命令
                run: function () {
                    var t = this;
                    var cmd = t.command;

                    if (cmd.charAt(0) !== '#') {
                        t.List[cmd]();
                    } else {
                        eval(cmd.substr(1));
                    }
                }
            }

        });

        // 初始化
        ui.ready(function (para) {
            if (para === null) {
                alert('没有找到调用方');
            }

            ui.setting.List = para.list;
            ui.setting.reset();
            ui.context.view.toSize('500px', '600px', true);
        });
    }
});