﻿
// 列表页面的范例
xf.module({

    name: 'v-view2-setting',

    using: [
        xf.builder('tkui'),
        xf.builder('tkui.grid')
    ],

    view: function (context, tkui) {

        // 初始化
        var ui = new tkui(context, {
            title: '查找关联'
        });

        // 搜索部分
        ui.vue('setting', {

            data: {
                tableName: '',
                tableComment: '',
                row: {},
                fields: [],
                map: {}
            },

            computed: {
                items: function () {
                    var t = this;
                    var arr = [];
                    for (var f of t.fields) {
                        var list = t.map[f.field];
                        if (!list) continue;

                        // 如果不是数组，转成数组 
                        if (!(list instanceof Array)) {
                            list = [list];
                        }

                        arr.push({
                            key: f.field,
                            name: f.name || f.field,
                            list: list
                        });
                    }
                    return arr;
                }
            },

            methods: {
                go: function (p, k) {
                    const t = this;
                    const condition = {}
                    condition[p.field] = t.row[k];
                    t.Page.close();
                    t.Page.goset('@' + p.sheet + '-grid', {
                        condition: condition
                    });
                }
            }

        });

        // 初始化
        ui.ready(function (para) {
            if (para === null) {
                alert('没有找到调用方');
            }

            var setting = ui.setting;

            setting.tableName = para.tableName;
            setting.tableComment = para.tableComment;
            setting.row = para.row;
            setting.fields = para.fields;
            setting.map = table_relate_map[setting.tableName] || {};

            context.view.title = para.tableComment + '('+ para.tableName + ') 的关联'

            ui.context.view.toSize('500px', '600px', true);
        });
    }
});