xf.module({

    name: 'v-views-sigin-in',

    using: [
        xf.builder('tkui'),
        xf.builder('tkui.form')
    ],

    view: function (context, tkui, form) {

        // 初始化
        var ui = new tkui(context, {
            title: '用户登录',
            controller: '',
            initModules: [form]
        });

        context.view.els.close.style.display = 'none';

        var body = ui.vue('tk-body', form.body, {

            static: {
                checker: {
                    name: { rgx: /.+/, msg: '用户名不能为空' },
                    password: { rgx: /.+/, msg: '密码不能为空' }
                }
            },

            data: {
                row: {
                    name: 'name', // 用户名
                    password: 'password' // 密码
                }
            },

            methods: {
                submit: function () {
                    var t = this;

                    var msg = t.Modal.checker(t.row, t.checker, { box: t.$el });
                    if (msg) { return; }

                    app.close();
                    app.goset('@home', {}, {
                        width: 0,
                        height: 0,
                        animate: 'bottom',
                        useDrag: false,
                        useCenter: false,
                        oncreated: function (v) {
                            v.els.view.classList.add('xv-home');
                        }
                    });
                }
            }

        });

        ui.ready();
    }
});