#!/usr/bin/env node

const fs = require('fs');

// 拷贝文件夹
function copyDir(src, dst) {

    const items = fs.readdirSync(src);
    if (!fs.existsSync(dst)) {
        fs.mkdirSync(dst);
    }

    for (let item of items) {
        const source = src + '/' + item;
        const target = dst + '/' + item;
        const info = fs.lstatSync(source);

        if (info.isFile()) {
            fs.writeFileSync(target, fs.readFileSync(source));
        }

        if (info.isDirectory()) {
            copyDir(source, target);
        }
    }
}

// 删除文件夹
function delDir(path) {

    let files = [];
    if (fs.existsSync(path)) {
        files = fs.readdirSync(path);
        files.forEach(function (file, index) {
            const curPath = path + "/" + file;
            const isDir = fs.statSync(curPath).isDirectory();
            isDir ? delDir(curPath) : fs.unlinkSync(curPath);
        });
        fs.rmdirSync(path);
    }
};


const [, , ...argv] = process.argv;
const dir = __dirname + '/code' + (argv[0] || '');
copyDir(dir, __dirname + '/../..');

// 删除初始化文件夹
delDir(__dirname + '/code');
delDir(__dirname + '/code-pure');

console.log('code copy success');

