
// 基类
declare class ApiBase {

    /** 上下文 */
    ctx: any;


    /** 错误信息 */
    failMsg: string[];


    /** 构造基础信息 */
    constructor(ctx: any);


    /** 获取并验证变量
     * @param val 输入的变量 
     * @param para 验证参数（数字的默认值/正则表达式/验证方法/枚举数组） 
     * @param failMsg 错误信息 
     */
    value(val: any, para?: number | RegExp | Array | Function, failMsg?: string): any;


    /** 判断是否存在失败信息 */
    isFailed: boolean;


    /** 返回失败信息 */
    fail(msg?: string): object;

    /** 返回成功信息 */
    success(data?: any): object;

    /** 获取用户ID */
    getUserID: number;
}

export = ApiBase;