
import Access from '../sql-kit/access';
import ApiBase from './apiBase';

// 生成查询参数
declare class SearchOpt {

    // #region [Types]

    order: string;
    pageIndex: number;
    pageSize: number;
    paras: Array<any>;

    _page: ApiBase;
    _where: Array<string>;
    _condition: any;

    // #endregion

    constructor(body: any, page: ApiBase);

    where: string;

    // 设置搜索条件
    setCondition(key: string, exp: string, para: any): SearchOpt;

    search(access: Access): Promise<object>;
}

// 基类
declare class ManageBase extends ApiBase {

    /** 配置结构数据 */
    buildSchema: ((body: any) => Promise<any>);


    /** 配置搜索数据 */
    buildSearcher: (body: any) => Promise<SearchOpt>;


    /** 配置添加/修改的数据 */
    buildData: (body: any, method?: string) => Promise<any>;


    /** 数据库入口 */
    access: Access;


    /** 返回成功信息 */
    output(data?: any): object;


    /** 生成查询配置 */
    searchOpt(body: any): SearchOpt;


    /** 获取概要 */
    $schema(body: any): Promise<any>;


    /** 搜索记录集 */
    $search(body: any): Promise<any>;


    /** 查找一条记录 */
    $find(body: any): Promise<any>;


    /** 创建一条记录 */
    $create(body: any): Promise<any>;


    /** 更新一条记录 */
    $update(body: any): Promise<any>;


    /** 移除一条记录 */
    $remove(body: any): Promise<any>;


}

export = ManageBase;