'use strict';

/** 用模板生成代码 */
const Coder = class {

    build(str) {
        const arr = str.split(/<%|%>/);
        const len = arr.length;
        const lines = [];
        let next = false;

        for (let i = 0; i < len; i++) {
            const item = arr[i] || '';

            // 添加静态字段
            if (i % 2 === 0) {
                const lineArr = item.split(/\r\n|\n/);
                let j = lineArr.length;
                for (const lineItem of lineArr) {
                    j--;
                    if (next) {
                        next = false;
                        continue;
                    }
                    lines.push('$b.addStr("' + encodeURIComponent(lineItem) + '");');
                    if (j > 0) { lines.push('$b.addStr("%0A");'); }
                }
                continue;
            }

            // 添加脚本
            const hd = item.charAt(0);
            switch (hd) {
                case '=':
                    lines.push('$b.addJs(' + item.substr(1) + ');');
                    break;
                case '#':
                    lines.pop();
                    lines.push(item.substr(1));
                    next = true;
                    break;
                default:
                    lines.push(item);
                    break;
            }
        }

        return lines.join('\n');
    }

    toStr(code, para) {

        para = para || {};

        para.lines = [];
        para.addStr = function (p) { para.lines.push(decodeURIComponent(p)) };
        para.addJs = function (p) { para.lines.push(p) };

        (new Function('$b', code))(para);

        return para.lines.join('');
    }

}

module.exports = function (str, para) {
    const cm = new Coder();
    const code = cm.build(str);
    return cm.toStr(code, para);
}