
// 设置环境和日志
module.exports = (env, log) => {

    // 输出配置
    console.log(JSON.stringify(env));

    // 设置日志
    if (typeof log !== 'function') {
        log = () => { };
    }

    return async (ctx, next) => {

        // 加入环境配置
        ctx.env = env;

        // 加入访问id
        ctx.rid = ctx.app.rid = (ctx.app.rid || 0) + 1;

        // 加入日志
        ctx.rlog = log;

        // 记录日志并继续执行
        ctx.rlog('req');
        await next();
        ctx.rlog('res');
    }
}